package stringify;

import java.util.List;
import java.util.Map.Entry;

import grammar.Grammar;

public class GrammarToString {

	public static String createGrammarString(Grammar grammar) {
		JSONObject grammarJSON = new JSONObject();
		JSONArray varsJSON = new JSONArray();
		for (String v : grammar.getVars()) {
			varsJSON.add(new JSONString(v));
		}
		JSONArray termsJSON = new JSONArray();
		for (int i = 97; i < 97 + grammar.getAlphaSize(); i++) {
			termsJSON.add(new JSONString(((char) i) + ""));
		}
		JSONArray rulesJSON = new JSONArray();
		int ruleNo = 1;
		for (Entry<String, List<List<String>>> rule : grammar.getRules().entrySet()) {
			String premise = rule.getKey();
			for (List<String> conclusio : rule.getValue()) {
				JSONObject ruleJSON = new JSONObject();
				JSONArray conclusioJSON = new JSONArray();
				for (String c : conclusio) {
					conclusioJSON.add(new JSONString(c));
				}
				ruleJSON.put("ruleNo", new JSONNumber(ruleNo++));
				ruleJSON.put("premise", new JSONString(premise));
				ruleJSON.put("conclusio", conclusioJSON);
				rulesJSON.add(ruleJSON);
			}
		}
		grammarJSON.put("variables", varsJSON);
		grammarJSON.put("terminals", termsJSON);
		grammarJSON.put("rules", rulesJSON);
		grammarJSON.put("start", new JSONString(grammar.getStart()));
		return grammarJSON.toString();
	}

	public static void main(String[] args) {

	}

}
