package stringify;

import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

public class JSONObject implements JSONDatatype {

	Map<String, JSONDatatype> obj;

	public JSONObject() {
		obj = new LinkedHashMap<>();
	}

	public void put(String key, JSONDatatype data) {
		obj.put(key, data);
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("{");
		Set<Entry<String, JSONDatatype>> entrySet = obj.entrySet();
		Iterator<Entry<String, JSONDatatype>> it = entrySet.iterator();
		while (it.hasNext()) {
			Entry<String, JSONDatatype> e = it.next();
			sb.append(new JSONString(e.getKey()).toString() + ":" + e.getValue().toString());
			if (it.hasNext()) {
				sb.append(",");
			}
		}
		sb.append("}");
		return sb.toString();
	}

}
